=== debian/changelog ===
rehex (0.4.1-0~ubuntu2104) hirsute; urgency=low

  * Fixed font-dependent rendering glitches when control characters or other
    Unicode oddities were present in the text view.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 Jan 2022 16:58:31 +0000

rehex (0.4.0-0~ubuntu2104) hirsute; urgency=low

  * Add data types for common text encodings (Unicode, ISO-8859) - text
    displayed or typed into the text view on the right will be decoded or
    encoded appropriately (#10).

  * Treat pasted text as text rather than a string of raw bytes.

  * Add 8-bit integer data types.

  * Don't mark new files as unsaved.

  * Store cursor position history and allow jumping backwards/forwards (#81).

  * Allow jumping to previous/next difference in data compare window (#131).

  * Collapse long ranges of identical data in data compare window (#85).

  * Added "Jump to offset in main window" to data compare window context menu.

  * Added shortcuts for comparing data (#103).

  * Add support for other encodings to strings tool (#106).

  * Add write protect flag to prevent accidental changes to file data during
    analysis (#130).

  * Respect system cursor blink speed setting (#112).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 20 Dec 2021 17:48:20 +0000

rehex (0.3.92-0~ubuntu2104+1) hirsute; urgency=low

  * Fix broken runtime depedency (libcapstone3 -> libcapstone4).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 25 Aug 2021 20:54:35 +0100

rehex (0.3.92-0~ubuntu2104) hirsute; urgency=low

  * Reduce persistent memory usage (#52).

  * Fully undo virtual mapping changes in one step (#126).

  * Fix build dependency errors (#129).

  * Add "Find previous" button to search dialogs (#111).

  * Fix hard-to-see colours in "Decode values" panel on some systems (#127).

  * Fix build errors on FreeBSD (#133).

  * Prevent document from jumping around when the window is resized or
    disassembly is in progress (#132).

  * Fix build errors when using wxWidgets 3.1.5 and newer.

  * Refactor selection handling to make sense in virtual section view (#125).

  * Add font face setting to "View" menu (#128).

  * Correctly track whether files have been modified since saving (#122).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 24 Aug 2021 22:50:23 +0100

rehex (0.3.91-0~ubuntu2104) hirsute; urgency=low

  * Fix loading of plugins bundled as part of an AppImage.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 May 2021 14:06:29 +0100

rehex (0.3.90-0~ubuntu2104) hirsute; urgency=low

  * Show disassembly of machine code in the main document view (#94).

  * Add font size settings to "View" menu (#97).

  * Add float/double types to "Set data type" menu (#104).

  * Fix selection by holding shift and clicking (#109).

  * Initial support for Lua plugins.

  * Process sections from PE EXE/DLL headers (#86).

  * [Mark Jansen] Save size of main window and tool panels (#88).

  * Don't resize tool panels unnecessarily.

  * Fix invalid cursor state when moving between regions.

  * Fix crash when deleting data (#113, #123).

  * Fix opening files with 8-bit filenames, and other encoding issues (#117).

  * Virtual segment mapping and display (#7).

  * Display inline comments by default (didn't always work).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 02 May 2021 21:09:21 +0100

rehex (0.3.1-0~ubuntu2010) groovy; urgency=low

  * Correctly display signed 16-bit values in "Decode values" panel.

  * Fix status bar offset going out of sync.

  * Move cursor when a row in the "Comments" panel is double clicked.

  * Focus document after updating position/selection via "Comments" panel.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 13 Nov 2020 22:33:10 +0000

rehex (0.3.0-0~ubuntu2010) groovy; urgency=low

  * [Mark Jansen] Use byte grouping setting from main window in diff window.

  * [Mark Jansen] Use Capstone disassembler rather than LLVM.

  * [Mark Jansen] Support disassembling 16-bit x86 machine code.

  * [Mark Jansen] Don't update tools which aren't visible.

  * [Vincent Bermel] Unhardcode linux launcher icon file type.

  * Fix an uncommon use-after-free crash when closing tabs in diff window.

  * Support for disassembling 6800/68000 and MOS6502 instruction sets
    (requires recent Capstone version).

  * [Mark Jansen] Close document when tab is clicked with middle mouse button.

  * [Mark Jansen] Don't create .rehex-meta files when there is nothing to save.

  * Implement Strings tool to find and list ASCII strings in the file.

  * Add option to calculate automatic bytes per line in whole byte groups.

  * Add "Fill range" tool for overwriting ranges of bytes with a pattern.

  * Preserve column alignment after comments.

  * [Mark Jansen] Mark a document dirty if highlighting is changed.

  * Add data type annotations.

  * Show ranges marked as integers in their decoded form in the hex view.

  * Performance improvements for documents with large numbers of comments.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 10 Nov 2020 13:20:11 +0000

rehex (0.2.0-0~ubuntu2010) UNRELEASED; urgency=low

  * Allow copying comments from a document and pasting them elsewhere in the
    same document or into another one.

  * Fixed bounds check when clicking on nested comments in a document.

  * Added context menu when right clicking on a comment in a document.

  * Optionally highlight byte sequences which match the current selection.
    ("Highlight data matching selection" or "PatternMatchHighlight").

  * Allow copying cursor offset from document context menu.

  * Correctly display offsets over 4GiB in the status bar.

  * Display offsets as XXXX:XXXX rather than XXXXXXXX:XXXXXXXX when the file
    size is under 4GiB.

  * Add per-document option for dec/hex offset display.

  * When first byte after a comment is deleted, show that the comment was

