=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 libcapstone-dev,
 debhelper (>= 9),
 libgtk-3-dev,
 libjansson-dev,
 libwxgtk3.0-gtk3-dev,
 liblua5.3-dev,
 libunistring-dev,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.0-headers,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcapstone4,
 libjansson4,
 liblua5.3-0,
 libunistring2,
 libwxgtk3.0-gtk3-0v5,
 zlib1g
Description: Reverse Engineers' Hex Editor
