## rehex 0.5.3

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Reverse Engineer's Hex Editor
-# Copyright (C) 2017-2021 Daniel Collins <solemnwarning@solemnwarning.net>
+# Copyright (C) 2017-2022 Daniel Collins <solemnwarning@solemnwarning.net>
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 as published by
@@ -23,6 +23,7 @@
 EXE ?= rehex
 EMBED_EXE ?= ./tools/embed
 GTKCONFIG_EXE ?= ./tools/gtk-config
+HELP_TARGET ?= help/rehex.htb
 
 # Wrapper around the $(shell) function that aborts the build if the command
 # exits with a nonzero status.
@@ -32,20 +33,47 @@
 		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
 		$(error $(1) exited with status $(lastword $(sod_out))))
 
-WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv)
-WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv)
-
-CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
-CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
-
-JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
-JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
-
-LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
-LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
-
-GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
-GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
+# Check if we are building target(s) that don't need to compile anything and
+# skip fetching compiler flags from wx-config/pkg-config/etc if so, this avoids
+# having to have our dependencies on build hosts that are going to use a chroot
+# or other container for doing the actual build.
+
+NONCOMPILE_TARGETS=clean distclean dist
+
+need_compiler_flags=1
+ifneq ($(MAKECMDGOALS),)
+	ifeq ($(filter-out $(NONCOMPILE_TARGETS),$(MAKECMDGOALS)),)
+		need_compiler_flags=0
+	endif
+endif
+
+ifeq ($(BUILD_HELP),)
+	BUILD_HELP=1
+endif
+
+ifeq ($(BUILD_HELP),0)
+	HELP_TARGET :=
+else
+	HELP_CFLAGS := -DBUILD_HELP
+	HELP_LIBS := html
+endif
+
+ifeq ($(need_compiler_flags),1)
+	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv $(HELP_LIBS))
+	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv $(HELP_LIBS))
+	
+	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
+	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
+	
+	JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
+	JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
+	
+	LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
+	LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
+	
+	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
+	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
+endif
 
 ifeq ($(DEBUG),)
 	DEBUG=0
@@ -57,9 +85,19 @@
 	DEBUG_CFLAGS := -ggdb
 endif
 
-CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
-CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
-CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
+ifeq ($(PROFILE),)
+	PROFILE=0
+endif
+
+ifeq ($(PROFILE),0)
+	PROFILE_CFLAGS :=
+else
+	PROFILE_CFLAGS := -DREHEX_PROFILE
+endif
+
+CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
+CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
+CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
 
 uname_S := $(shell uname -s 2>/dev/null)
 ifeq ($(uname_S),FreeBSD)
@@ -72,7 +110,7 @@
 LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)
 
 # Define this for releases
-VERSION := 0.4.1
+VERSION := 0.5.3
 
 ifdef VERSION
 	LONG_VERSION := Version $(VERSION)
@@ -88,8 +126,8 @@
 	
 	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
 	
-	VERSION      := 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
-	LONG_VERSION := Snapshot 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
+	VERSION      := 42f8b1c8f3532351221b1d1e8d4dd4f60a28713a
+	LONG_VERSION := Snapshot 42f8b1c8f3532351221b1d1e8d4dd4f60a28713a
 endif
 
 DEPDIR := .d
@@ -111,6 +149,11 @@
 .PHONY: check
 check: tests/all-tests
 	./tests/all-tests
+	
+	for p in $(PLUGINS); \
+	do \
+		$(MAKE) -C plugins/$${p} LUA=$(LUA) check || exit $$?; \
+	done
 
 .PHONY: clean
 clean:
@@ -193,6 +236,7 @@
 	wxLua/modules/wxbind/src/wxpropgrid_bind.o
 
 APP_OBJS := \
+	res/actual_size16.o \
 	res/ascii16.o \
 	res/ascii24.o \
 	res/ascii32.o \
@@ -201,6 +245,7 @@
 	res/diff_fold24.o \
 	res/diff_fold32.o \
 	res/diff_fold48.o \
+	res/fit_to_screen16.o \
 	res/icon16.o \
 	res/icon32.o \
 	res/icon48.o \
@@ -212,15 +257,22 @@
 	res/offsets32.o \
 	res/offsets48.o \
 	res/spinner24.o \
+	res/swap_horiz16.o \
+	res/swap_vert16.o \
+	res/zoom_in16.o \
+	res/zoom_out16.o \
 	src/AboutDialog.o \
 	src/AppMain.o \
+	src/AppSettings.o \
 	src/AppTestable.o \
 	src/ArtProvider.o \
 	src/BasicDataTypes.o \
+	src/BitmapTool.o \
 	src/buffer.o \
 	src/BytesPerLineDialog.o \
 	src/ByteRangeSet.o \
 	src/CharacterEncoder.o \
+	src/CharacterFinder.o \
 	src/ClickText.o \
 	src/CodeCtrl.o \
 	src/CommentTree.o \
@@ -236,12 +288,15 @@
 	src/EditCommentDialog.o \
 	src/Events.o \
 	src/FillRangeDialog.o \
+	src/IntelHexExport.o \
+	src/IntelHexImport.o \
 	src/LicenseDialog.o \
 	src/lua-bindings/rehex_bind.o \
 	src/lua-plugin-preload.o \
 	src/LuaPluginLoader.o \
 	src/mainwindow.o \
 	src/Palette.o \
+	src/profile.o \
 	src/search.o \
 	src/SelectRangeDialog.o \
 	src/StringPanel.o \
@@ -257,11 +312,12 @@
 	$(EXTRA_APP_OBJS)
 
 $(EXE): $(APP_OBJS) $(GTKCONFIG_EXE)
-	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
+	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -DDATADIR='"$(datadir)"' -c -o res/version.o res/version.cpp
 	$(CXX) $(CXXFLAGS) -o $@ $(APP_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)
 
 TEST_OBJS := \
 	googletest/src/gtest-all.o \
+	res/actual_size16.o \
 	res/ascii16.o \
 	res/ascii24.o \
 	res/ascii32.o \
@@ -270,6 +326,7 @@
 	res/diff_fold24.o \
 	res/diff_fold32.o \
 	res/diff_fold48.o \
+	res/fit_to_screen16.o \
 	res/icon16.o \
 	res/icon32.o \
 	res/icon48.o \
@@ -281,14 +338,21 @@
 	res/offsets32.o \
 	res/offsets48.o \
 	res/spinner24.o \
+	res/swap_horiz16.o \
+	res/swap_vert16.o \
+	res/zoom_in16.o \
+	res/zoom_out16.o \
 	src/AboutDialog.o \
+	src/AppSettings.o \
 	src/AppTestable.o \
 	src/ArtProvider.o \
 	src/BasicDataTypes.o \
+	src/BitmapTool.o \
 	src/buffer.o \
 	src/ByteRangeSet.o \
 	src/BytesPerLineDialog.o \
 	src/CharacterEncoder.o \
+	src/CharacterFinder.o \
 	src/ClickText.o \
 	src/CommentTree.o \
 	src/ConsoleBuffer.o \
@@ -300,6 +364,8 @@
 	src/EditCommentDialog.o \
 	src/Events.o \
 	src/FillRangeDialog.o \
+	src/IntelHexExport.o \
+	src/IntelHexImport.o \
 	src/LicenseDialog.o \
 	src/lua-bindings/rehex_bind.o \
 	src/lua-plugin-preload.o \
@@ -315,10 +381,12 @@
 	src/util.o \
 	src/VirtualMappingDialog.o \
 	src/win32lib.o \
+	tests/BitmapTool.o \
 	tests/buffer.o \
 	tests/ByteRangeMap.o \
 	tests/ByteRangeSet.o \
 	tests/CharacterEncoder.o \
+	tests/CharacterFinder.o \
 	tests/CommentsDataObject.o \
 	tests/CommentTree.o \
 	tests/ConsoleBuffer.o \
@@ -326,6 +394,9 @@
 	tests/DisassemblyRegion.o \
 	tests/Document.o \
 	tests/DocumentCtrl.o \
+	tests/FastRectangleFiller.o \
+	tests/IntelHexExport.o \
+	tests/IntelHexImport.o \
 	tests/LuaPluginLoader.o \
 	tests/main.o \
 	tests/NestedOffsetLengthMap.o \
@@ -337,49 +408,3 @@
 	tests/SafeWindowPointer.o \
 	tests/SharedDocumentPointer.o \
 	tests/StringPanel.o \
-	tests/Tab.o \
-	tests/util.o \
-	$(WXLUA_OBJS) \
-	$(WXBIND_OBJS) \
-	$(EXTRA_TEST_OBJS)
-
-tests/all-tests: $(TEST_OBJS) $(GTKCONFIG_EXE)
-	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
-	$(CXX) $(CXXFLAGS) -o $@ $(TEST_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)
-
-$(EMBED_EXE): tools/embed.cpp
-	$(CXX) $(CXXFLAGS_NO_GTK) -o $@ $<
-
-$(GTKCONFIG_EXE): tools/gtk-config.cpp
-	$(CXX) $(CXXFLAGS_NO_GTK) $(WX_CXXFLAGS) -o $@ $<
-
-src/AboutDialog.o: res/icon128.h
-src/ArtProvider.o: \
-	res/ascii16.h res/ascii24.h res/ascii32.h res/ascii48.h \
-	res/diff_fold16.h res/diff_fold24.h res/diff_fold32.h res/diff_fold48.h \
-	res/offsets16.h res/offsets24.h res/offsets32.h res/offsets48.h
-src/DiffWindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
-src/LicenseDialog.o: res/license.h
-src/LuaPluginLoader.o: src/lua-bindings/rehex_bind.h src/lua-plugin-preload.h
-src/mainwindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
-src/StringPanel.o: res/spinner24.h
-
-res/license.done: LICENSE.txt $(EMBED_EXE)
-	$(EMBED_EXE) $< LICENSE_TXT res/license.c res/license.h
-	touch $@
-
-res/license.c res/license.h: res/license.done ;
-
-res/%.c res/%.h: res/%.png $(EMBED_EXE)
-	$(EMBED_EXE) $< $*_png res/$*.c res/$*.h
-
-res/%.c res/%.h: res/%.gif $(EMBED_EXE)
-	$(EMBED_EXE) $< $*_gif res/$*.c res/$*.h
-
-src/lua-bindings/rehex_bind.done: src/lua-bindings/rehex.i src/lua-bindings/rehex_override.hpp src/lua-bindings/rehex_rules.lua $(WXLUA_BINDINGS)
-	$(LUA) -e"rulesFilename=\"src/lua-bindings/rehex_rules.lua\"" wxLua/bindings/genwxbind.lua
-	
-	# genwxbind.lua may not modify individual files if they are already up to date.
-	touch -c src/lua-bindings/rehex_bind.cpp
-	touch -c src/lua-bindings/rehex_bind.h
-
